global asm_invertir_internal
global asm_calcular_corte_fotoBinaria_internal
global asm_bordesSimples_internal
global asm_bordesSobel_internal
global asm_BlackAndWhite_internal
global asm_zoom_internal
global asm_fotoBinaria_internal
global asm_filtroGauseano_internal
global asm_bordesCanny_internal

global asm_zoomBillinear_internal
global asm_duplicarContraste_internal
global asm_colorBalance_internal
global asm_bokeh_internal
global asm_nearestRot_internal

extern malloc
extern memcpy
extern free
extern exit

section .text

;extern "C" void asm_bordesCanny_internal(unsigned char *Imagen, int h, int w, int ws, bool ByN, bool binario,
;                                        int *movx, int *movy, int *valorH, int *valorV, char *Emag, char *Egra);
asm_bordesCanny_internal:
		%define Imagen  dword [ebp + 8 + 4*0]
        %define h       dword [ebp + 8 + 4*1]
        %define w       dword [ebp + 8 + 4*2]
        %define ws      dword [ebp + 8 + 4*3]
        %define ByN     dword [ebp + 8 + 4*4]
        %define binario dword [ebp + 8 + 4*5]
        
        %define movx   dword [ebp + 8 + 4*6]
        %define movy   dword [ebp + 8 + 4*7]
        %define valorH dword [ebp + 8 + 4*8]
        %define valorV dword [ebp + 8 + 4*9]
        %define Emag   dword [ebp + 8 + 4*10]
        %define Egra   dword [ebp + 8 + 4*11]
        
        %define valH dword [ebp - 4]
        %define valV dword [ebp - 8]

        enter 8,0
        pusha
        
		mov eax, w
		dec eax
		mov esi, 3
		mul esi
		mov w, eax

		mov eax, h
		dec eax
		mov h, eax
		xor esi,esi
        mov ecx, 1
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			mov ebx,3
			push ecx
			mov ecx, Emag
			add ecx, eax
.cicloW:	 ;// no modificar ebx, edi
				
				mov valH, 0
				mov valV, 0
				xor esi,esi ;
			.cicloK:
					;//valH+= ([edi+movy[k]+ebx+movx[k]]) * valorH[k];					
					mov edx, movx
					mov edx, [edx + esi *4]
					add edi,edx
					mov edx, movy
					mov edx, [edx + esi *4]
					add ebx,edx
					
					xor eax,eax
					mov al, [edi+ebx]
					
					mov edx, movx
					mov edx, [edx + esi*4]
					sub edi, edx
					mov edx, movy
					mov edx, [edx + esi *4]
					sub ebx, edx
					
					mov edx, valorH
					mov edx, [edx + esi*4]
					imul edx
					add valH, eax


					;//valV+= ([edi+movy[k]+ebx+movx[k]]) * valorV[k];
					
					mov edx, movx
					add ebx, [edx + esi*4]
					mov edx, movy
					add edi, [edx + esi *4]
					
					xor eax,eax
					mov al, [edi+ebx]

					mov edx, movx
					sub ebx, [edx + esi*4]
					mov edx, movy
					sub edi, [edx + esi *4]

					mov edx, valorV
					mov edx, [edx + esi*4]
					imul edx
					add valV, eax
					
					


					inc esi
					cmp esi, 9
					jne .cicloK

				;// sum = eax = abs(valH) +abs(valV)
				mov esi, valH	
				add esi, 0
				jns .elsee3
				mov eax, -1
				imul esi
				mov esi,eax
			.elsee3:
				mov eax, esi
				
				mov edx, valV	
				add edx, 0
				jns .elsee2
				mov eax, -1
				imul edx
				mov edx,eax
			.elsee2:
				mov eax, edx
				add eax, esi
				;// fin eax = abs..

				;// if (sum > 255) sum = 255
				cmp ah, 0
				je .elsee
				mov al,0
.elsee:
				;// if (sum < 30) sum = 0
				
					
				mov  [ecx+ ebx], al
				
				
				
				
				
				
				
				
				mov eax, valH
				mov edx, 1000
				imul edx
				mov valH, eax
				mov esi, edi
				sub esi, Imagen
				add esi, Egra
				add esi, ebx
				;//aux = 0;
				mov eax, 0
				mov [esi], al
				;//if (valH*1000 > valV*-425 && valH*1000 < valV * 425) aux = 4;
				mov eax, valV
				mov edx, -425
				imul edx
				cmp eax, valH ;// compara con signo??????????????????
				jg .no4
					mov eax, valV
					mov edx, 425
					imul edx
					cmp eax, valH
					jl .no4
						mov eax, 4
						mov [esi], al
				.no4:

				;//if (valH*1000 <valV*-425 && valH*1000 < valV *-2425)	aux = 8;
				mov eax, valV
				mov edx, -425
				imul edx
				cmp eax, valH ;// compara con signo??????????????????
				jl .no8
					mov eax, valV
					mov edx, -2425
					imul edx
					cmp eax, valH
					jl .no8
						mov eax, 7
						mov [esi], al
				.no8:

				;//if (valH*1000 >valV*425 && valH*1000 < valV *2425)	aux = 7;
				mov eax, valV
				mov edx, 425
				imul edx
				cmp eax, valH ;// compara con signo??????????????????
				jg .no7
					mov eax, valV
					mov edx, 2425
					imul edx
					cmp eax, valH
					jl .no7
						mov eax,8 
						mov [esi], al
.no7:


				add ebx, 3
				cmp ebx, w
        		jne .cicloW 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

		
		mov ecx, 1
    .cicloH2:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			mov ebx,3
			push ecx
			mov esi, Emag
			add esi, eax
.cicloW2:	 ;// no modificar ebx, edi
				
				mov valH, 0
				mov valV, 0
				xor ecx,ecx ;
				mov [edi+ ebx], ecx ;//pone 4byte en 0 
				mov eax, esi
				sub eax, Emag
				add eax, Egra
				xor ecx, ecx
				mov cl, [eax + ebx] ;// ecx = k
				
				
				 
				;//if (Emag[esi+EBX] >= Emag[(esi + movy[k] +EBX+movx[k]] 
					mov edx, movx
					mov edx, [edx + ecx *4]
					add ebx,edx
					mov edx, movy
					mov edx, [edx + ecx *4]					
					add esi,edx

					xor eax,eax
					mov al, [esi+ ebx ]
					
					mov edx, movx
					mov edx, [edx + ecx*4]
					sub ebx, edx
					mov edx, movy
					mov edx, [edx + ecx *4]					
					sub esi, edx

					xor edx, edx
					mov dl, [esi+ ebx]
					cmp eax, edx
					jg .finif2

				;//&& Emag[esi+EBX] >= Emag[esi+movy[k]*-1+EBX+movx[k]*-1])
					mov edx, movx
					mov edx, [edx + ecx *4]
					sub esi,edx
					mov edx, movy
					mov edx, [edx + ecx *4]
					sub ebx,edx
					
					xor eax,eax
					mov al, [esi+ebx]
					
					mov edx, movx
					mov edx, [edx + ecx*4]
					add esi, edx
					mov edx, movy
					mov edx, [edx + ecx *4]
					add ebx, edx

					xor edx, edx
					mov dl, [esi+ ebx]
					cmp eax, edx
					jg .finif2

				mov al,[esi + ebx]									
				mov  [edi+ ebx], al
				mov  [edi+ ebx+1], al
				mov  [edi+ ebx+2], al
			.finif2:
				
				add ebx, 3
				cmp ebx, w
        		jne .cicloW2 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH2 
    
    popa
    leave
    ret

;extern "C" void asm_calcular_corte_fotoBinaria_internal(unsigned char *Imagen, int h, int w, int ws, 
;                                                int corteint, int *sumtecho, int *sumpiso, int *cantecho, int *canpiso);
asm_calcular_corte_fotoBinaria_internal:
        
        %define Imagen   dword [ebp + 8 + 4*0]
        %define h        dword [ebp + 8 + 4*1]
        %define w        dword [ebp + 8 + 4*2]
        %define ws       dword [ebp + 8 + 4*3]
        
        %define corteint    dword [ebp + 8 + 4*4]
        %define sumtechoPtr dword [ebp + 8 + 4*5]
        %define sumpisoPtr  dword [ebp + 8 + 4*6]
        %define cantechoPtr dword [ebp + 8 + 4*7]
        %define canpisoPtr  dword [ebp + 8 + 4*8]
        
        %define sumtecho dword [ebp - 4]
        %define sumpiso  dword [ebp - 8]
        %define cantecho dword [ebp - 12]
        %define canpiso  dword [ebp - 16]
        
        enter 16,0

		pusha
        
        mov eax, sumtechoPtr
        mov eax, [eax]
        mov sumtecho , eax
        
        mov eax, sumpisoPtr
        mov eax, [eax]
        mov sumpiso , eax
        
        mov eax, cantechoPtr
        mov eax, [eax]
        mov cantecho , eax
        
        mov eax, canpisoPtr
        mov eax, [eax]
        mov canpiso , eax
        
		xor esi,esi
        mov ecx, 0
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			xor ebx,ebx 

.cicloW:
				xor edx, edx
				xor eax,eax
				mov al, [edi+ebx]
				add edx, eax
				mov al, [edi+ebx+1]
				add edx, eax
				mov al, [edi+ebx+2]
				add edx, eax

				xor eax,eax
				cmp edx, corteint
				jl .elsee
					add cantecho, 1
					add sumtecho, edx;
					jmp .finif
.elsee:
					add canpiso, 1
					add sumpiso, edx;
				
			.finif:

				add ebx,3
				cmp ebx, w
        		jne .cicloW 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

        mov eax, sumtecho
        mov ebx, sumtechoPtr
        mov [ebx], eax
        
        mov eax, sumpiso
        mov ebx, sumpisoPtr
        mov [ebx], eax
        
        mov eax, cantecho
        mov ebx, cantechoPtr
        mov [ebx], eax
        
        mov eax, canpiso
        mov ebx, canpisoPtr
        mov [ebx], eax

			popa
        
        leave
        ret


;extern "C" void asm_fotoBinaria_internal(unsigned char *Imagen, int h, int w, int ws, int corte);
asm_fotoBinaria_internal:

        %define Imagen   dword [ebp + 8 + 4*0]
        %define h        dword [ebp + 8 + 4*1]
        %define w        dword [ebp + 8 + 4*2]
        %define ws       dword [ebp + 8 + 4*3]
        %define corte    dword [ebp + 8 + 4*4]
    
        enter 0,0
        pusha
    
		mov eax, w
		mov esi, 3
		mul esi
		mov w, eax
		xor esi,esi
        mov ecx, 0
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			xor ebx,ebx 

.cicloW:
				xor edx, edx
				xor eax,eax
				mov al, [edi+ebx]
				add edx, eax
				mov al, [edi+ebx+1]
				add edx, eax
				mov al, [edi+ebx+2]
				add edx, eax

				xor eax,eax
				cmp edx, corte
				jl .elsee
				mov eax, 255
				.elsee:
				

				mov [edi+ebx], al
				mov [edi+ebx+1], al
				mov [edi+ebx+2], al

				add ebx,3
				cmp ebx, w
        		jne .cicloW 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

        popa
       leave
       ret


;extern "C" void asm_filtroGauseano_internal(unsigned char *Imagen, int h, int w, int ws, bool ByN, int *movx, int *movy, int *valores);
asm_filtroGauseano_internal:
        
        %define Imagen   dword [ebp + 8 + 4*0]
        %define h        dword [ebp + 8 + 4*1]
        %define w        dword [ebp + 8 + 4*2]
        %define ws       dword [ebp + 8 + 4*3]
        %define ByN      dword [ebp + 8 + 4*4]
        %define movx     dword [ebp + 8 + 4*5]
        %define movy     dword [ebp + 8 + 4*6]
        %define valores  dword [ebp + 8 + 4*7]

        
        enter 0,0
        pusha

		mov eax, w
		sub eax,2
		mov esi, 3
		mul esi
		mov w, eax

		mov eax, h
		dec eax
		dec eax
		mov h, eax
		xor esi,esi
        mov ecx, 2
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			mov ebx,6
			push ecx
			
.cicloW:	 ;// no modificar ebx, edi
				
				mov ecx, 0
				xor esi,esi ;
			.cicloK:
					;//sum+= I[y+movx[k]+i+movy[k])] )*valores[k];				
					mov edx, movx
					mov edx, [edx + esi *4]
					add edi,edx
					mov edx, movy
					mov edx, [edx + esi *4]
					add ebx,edx
					
					xor eax,eax
					mov al, [edi+ebx]
					
					mov edx, movx
					mov edx, [edx + esi*4]
					sub edi, edx
					mov edx, movy
					mov edx, [edx + esi *4]
					sub ebx, edx
					
					mov edx, valores
					mov edx, [edx + esi*4]
					imul edx
					add ecx, eax

					inc esi
					cmp esi, 25
					jne .cicloK

				
				mov eax, ecx
				mov esi, 273
				div esi
				
					
				mov  [edi+ ebx], al

				inc ebx
				cmp ebx, w
        		jne .cicloW 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

    popa
    leave
    ret


;extern "C" void asm_zoom_internal(unsigned char *Imagen, int h, int w, int ws, 
;                                    int inih, int iniw, int finh, int finw,char *out);

asm_zoom_internal:

        %define Imagen   dword [ebp + 8 + 4*0]
        %define h        dword [ebp + 8 + 4*1]
        %define w        dword [ebp + 8 + 4*2]
        %define ws       dword [ebp + 8 + 4*3]
        %define inih     dword [ebp + 8 + 4*4]
        %define iniw     dword [ebp + 8 + 4*5]
        %define finh     dword [ebp + 8 + 4*6]
        %define finw     dword [ebp + 8 + 4*7]
        %define out      dword [ebp + 8 + 4*8]
    
    
        %define hh dword [ebp -4]
        %define ww dword [ebp -8]
    
    
    enter 8,0
    pusha
    
        mov hh, 0
        mov ww, 0
    
		xor esi,esi
        mov ecx, inih
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			
			mov ebx, iniw
			push ecx
			mov ecx, out
			mov eax, hh
			
			mov edx, ws
			mul edx			
			add ecx, eax
			mov ww, 0
.cicloW:
				mov eax, [edi + ebx]
				mov edx, ww
				mov [ecx + edx], eax
				mov [ecx + edx + 3], eax
				add edx, ws
				mov [ecx + edx], eax
				mov [ecx + edx + 3], eax
				
				mov eax, [edi + ebx+1]
				mov edx, ww
				mov [ecx + edx +1], eax
				mov [ecx + edx + 3+1], eax
				add edx, ws
				mov [ecx + edx+1], eax
				mov [ecx + edx + 3+1], eax

				
				mov eax, [edi + ebx+2]
				mov edx, ww
				mov [ecx + edx+2], eax
				mov [ecx + edx + 3+2], eax
				add edx, ws
				mov [ecx + edx+2], eax
				mov [ecx + edx + 3+2], eax
				
				add ww, 6;//cuidado!!!!!!!!!!!!
				add ebx, 3
				cmp ebx, finw
        		jne .cicloW 
            
			pop ecx
			add hh, 2
			inc ecx
            cmp ecx, finh
        	jne .cicloH 

       ;// pasar out a I
			
			mov ecx, 0
    .cicloH2:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			mov esi, out
			add esi, eax
			xor ebx,ebx 

.cicloW2:				
				mov eax, [esi + ebx]
				mov [edi + ebx], eax

				inc ebx
				cmp ebx, w
        		jne .cicloW2 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH2


    popa
    leave
    ret


;extern "C" void asm_bordesSobel_internal(unsigned char *Imagen, int h, int w, int ws, 
;                                        int *movx, int *movy, int *valorH, int *valorV, char *out);
asm_bordesSobel_internal:

    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
    
    %define movx   dword [ebp + 8 + 4*4]
    %define movy   dword [ebp + 8 + 4*5]
    %define valorH dword [ebp + 8 + 4*6]
    %define valorV dword [ebp + 8 + 4*7]
    %define out    dword [ebp + 8 + 4*8]
    
    %define valH dword [ebp - 4]
    %define valV dword [ebp - 8]

    enter 8, 0
    pusha

		mov eax, w
		dec eax
		mov esi, 3
		mul esi
		mov w, eax

		mov eax, h
		dec eax
		mov h, eax
		xor esi,esi
        mov ecx, 1
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			mov ebx,3
			push ecx
			mov ecx, out
			add ecx, eax
.cicloW:	 ;// no modificar ebx, edi
				
				mov valH, 0
				mov valV, 0
				xor esi,esi ;
			.cicloK:
					;//valH+= ([edi+movy[k]+ebx+movx[k]]) * valorH[k];					
					mov edx, movx
					mov edx, [edx + esi *4]
					add edi,edx
					mov edx, movy
					mov edx, [edx + esi *4]
					add ebx,edx
					
					xor eax,eax
					mov al, [edi+ebx]
					
					mov edx, movx
					mov edx, [edx + esi*4]
					sub edi, edx
					mov edx, movy
					mov edx, [edx + esi *4]
					sub ebx, edx
					
					mov edx, valorH
					mov edx, [edx + esi*4]
					imul edx
					add valH, eax


					;//valV+= ([edi+movy[k]+ebx+movx[k]]) * valorV[k];
					
					mov edx, movx
					add ebx, [edx + esi*4]
					mov edx, movy
					add edi, [edx + esi *4]
					
					xor eax,eax
					mov al, [edi+ebx]

					mov edx, movx
					sub ebx, [edx + esi*4]
					mov edx, movy
					sub edi, [edx + esi *4]

					mov edx, valorV
					mov edx, [edx + esi*4]
					imul edx
					add valV, eax
					
					


					inc esi
					cmp esi, 9
					jne .cicloK

				
				mov esi, valH	
				add esi, 0
				jns .elsee3
				mov eax, -1
				imul esi
				mov esi,eax
			.elsee3:
				mov eax, esi
				
				mov edx, valV	
				add edx, 0
				jns .elsee2
				mov eax, -1
				imul edx
				mov edx,eax
			.elsee2:
				mov eax, edx
				add eax, esi
				cmp ah, 0
				je .elsee
				mov al,255
.elsee:
				
					
				mov  [ecx+ ebx], al

				inc ebx
				cmp ebx, w
        		jne .cicloW 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 
	;// pasar out a I
			
			mov ecx, 0
    .cicloH2:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			mov esi, out
			add esi, eax
			xor ebx,ebx 

.cicloW2:				
				mov eax, [esi + ebx]
				mov [edi + ebx], eax

				inc ebx
				cmp ebx, w
        		jne .cicloW2 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH2
    
    popa
    leave
    ret

;extern "C" void asm_invertir_internal(unsigned char *Imagen, int h, int w, int ws);

asm_invertir_internal:

    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]

    enter 0,0
    pusha

		mov eax, w
		mov esi, 3
		mul esi
		mov w, eax
		xor esi,esi
        mov ecx, 0
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax
			xor ebx,ebx 

.cicloW:
				xor edx, edx
				mov eax, 255
				mov dl, [edi + ebx]
				sub eax, edx
				mov  [edi + ebx], al
				inc ebx
				cmp ebx, w
        		jne .cicloW 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 

    popa
    leave
    ret

;extern "C" void asm_BlackAndWhite_internal(unsigned char *Imagen, int h, int w, int ws);

asm_BlackAndWhite_internal:

    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
    
    enter 0,0
    pusha
    
		mov eax, w
		mov esi, 3
		mul esi
		mov w, eax
		xor esi,esi
        mov ecx, 0
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			xor ebx, ebx
.cicloW:
				xor esi, esi
				xor eax,eax
				
				mov al, [edi + ebx]
				mov edx, 30
				mul edx
				add esi, eax
				xor eax,eax
				mov al, [edi + ebx+1]
				mov edx, 59
				mul edx
				add esi, eax
				xor eax,eax
				mov al, [edi + ebx+2]
				mov edx, 11
				mul edx
				add esi, eax
				
				mov eax, esi
				mov esi, 100
				div esi

				mov  [edi + ebx], al
				mov  [edi + ebx+1], al
				mov  [edi + ebx+2], al

				add ebx, 11b
				cmp ebx, w
        		jne .cicloW 
            
			
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 
            
    popa
    leave
    ret

;extern "C" void asm_bordesSimples_internal(unsigned char *Imagen, int h, int w, int ws);
asm_bordesSimples_internal:


    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]

    enter 0,0
    pusha

		mov eax, w
		dec eax
		mov esi, 3
		mul esi
		mov w, eax

		mov eax, h
		dec eax
		mov h, eax
		xor esi,esi
        mov ecx, 0
    .cicloH:
    		mov edi, Imagen
			mov eax, ws
			mul ecx
			add edi, eax		
			xor ebx, ebx
			push ecx
.cicloW:	 ;// no modificar ebx, edi
				xor esi, esi ;//esi = sum
				xor eax,eax
				xor edx,edx
				mov al, [edi + ebx]
				mov dl, [edi + ebx+3]
				;//ABS(eax-edx)	
				mov ecx, eax
				sub eax, edx
				sub edx, ecx
				cmovg eax, edx	
				;//

				add esi, eax


				xor eax,eax
				xor edx,edx
				mov al, [edi + ebx+1]
				mov dl, [edi + ebx+3+1]
				;//ABS(eax-edx)	
				mov ecx, eax
				sub eax, edx
				sub edx, ecx
				cmovg eax, edx	
				;//

				add esi, eax

				xor eax,eax
				xor edx,edx
				mov al, [edi + ebx+2]
				mov dl, [edi + ebx+3+2]
				
				;//ABS(eax-edx)	
				mov ecx, eax
				sub eax, edx
				sub edx, ecx
				cmovg eax, edx	
				;//

				add esi, eax
				
				;//abajo
				
				xor eax,eax
				xor edx,edx
				mov al, [edi + ebx+0]
				add edi, ws
				mov dl, [edi + ebx+0]
				sub edi,ws
				;//ABS(eax-edx)	
				mov ecx, eax
				sub eax, edx
				sub edx, ecx
				cmovg eax, edx	
				;//

				add esi, eax

				xor eax,eax
				xor edx,edx
				mov al, [edi + ebx+1]
				add edi, ws
				mov dl, [edi + ebx+1]
				sub edi,ws
				;//ABS(eax-edx)	
				mov ecx, eax
				sub eax, edx
				sub edx, ecx
				cmovg eax, edx	
				;//

				add esi, eax

				xor eax,eax
				xor edx,edx
				mov al, [edi + ebx+2]
				add edi, ws
				mov dl, [edi + ebx+2]
				sub edi,ws
				;//ABS(eax-edx)	
				mov ecx, eax
				sub eax, edx
				sub edx, ecx
				cmovg eax, edx	
				;//

				add esi, eax


				mov eax, esi
				cmp ah, 0
				je .elsee
				mov al,255
				.elsee:
				mov  [edi + ebx], al
				mov  [edi + ebx+1], al
				mov  [edi + ebx+2], al

				add ebx, 11b
				cmp ebx, w
        		jne .cicloW 
            
			pop ecx
			
			inc ecx
            cmp ecx, h
        	jne .cicloH 


    popa
    leave
    ret

; extern "C" void asm_zoomBillinear_internal(unsigned char *Imagen, int h, int w, int ws);

asm_zoomBillinear_internal:
    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
    
    %define auxBase     dword [ebp - 4 * 1]
    %define base        dword [ebp - 4 * 2]
    %define i           dword [ebp - 4 * 3]
    %define j           dword [ebp - 4 * 4]
    
    enter 4 * 4,0
    pusha
        
        mov ebx, h ; int h = frame->height;
        mov edi, ws ; const int WS = frame->widthStep;
        
        mov esi, edi
        imul esi, ebx
        push esi
        call malloc
        add esp, 4
        mov auxBase, eax ; uchar *auxBase = (uchar*)malloc(WS*h);
        
        push esi
        push Imagen
        push eax ; memcpy(auxBase,frame->imageData,WS*h);
        call memcpy
        add esp, 4 * 3

        shr ebx, 2
        imul ebx, edi ; ebx = WS * (h/4)
        
        mov edx, w ; int w = frame->width;        
        shr edx, 2
        lea edx, [edx + 2*edx] ; edx = 3 * (w/4)
        
        add ebx, edx
        add ebx, auxBase
        sub ebx, edi
        sub ebx, 3    ; Offsets + WS + 3
        mov base, ebx  ; const uchar *base = auxBase + 3*(w/4) + WS * (h/4);
        
        ; uchar *outputBase = (uchar*)frame->imageData;
        
        mov eax, h
        shr eax, 1 ; i = h/2, loop down
        mov i, eax ; {
        xor eax, eax
        xor ecx, ecx
.loopI:
            mov ebx, base ; const uchar *centro = base;
            mov esi, Imagen ; uchar *output = outputBase;
            mov edx, w; for(int j = 0 ; j < w/2 ; j++)
            shr edx, 1
            mov j, edx
            xor edx, edx
            .loopJ:
                    %assign k 0
                    %rep 3
                        xor ch, ch
                        mov cl, [ebx + edi + 3 + k]
                        lea ecx, [ecx + 8*ecx]
                        ; unsigned A = centro[0], B,C,D; A = 9*A;
                        ;// Superiores
                        ;C = centro[-WS];
                        ;// Superior izquierdo
                        ;B = centro[-3];
                        ;D = centro[-WS-3];
                        mov al, [ebx + 3 + k]
                        mov dl, [ebx + edi + k]
                        add eax, edx
                        lea eax, [eax + 2*eax]
                        mov dl,  [ebx + k]
                        add eax, edx
                        add eax, ecx
                        shr eax, 4
                        mov [esi + k], al; output[0] = (9 * A + 3 * (B+C) + D) / 16;
                        ;// Superior derecho
                        ;B = centro[3];
                        ;D = centro[-WS+3];
                        mov al, [ebx + edi + 6 + k]
                        mov dl,  [ebx + 3 + k]
                        add eax, edx
                        lea eax, [eax + 2*eax]
                        mov dl,  [ebx + 6 + k]
                        add eax, edx
                        add eax, ecx
                        shr eax, 4
                        mov [esi + 3 + k], al ; output[3] = (9 * A + 3 * (B+C) + D) / 16;
                        ;// Inferiores
                        ;C = centro[WS];
                        ;// Inferior izquierdo
                        ;B = centro[-3];
                        ;D = centro[WS-3];
                        mov al, [ebx + edi + k]
                        mov dl,  [ebx + 2 * edi + 3 + k]
                        add eax, edx
                        lea eax, [eax + 2*eax]
                        mov dl, [ebx + 2 * edi + k]
                        add eax, edx
                        add eax, ecx
                        shr eax, 4
                        mov [esi + edi + k], al ; output[WS] = (9 * A + 3 * (B+C) + D) / 16;
                        ;// Inferior derecho
                        ;B = centro[3];
                        ;D = centro[WS+3];
                        mov al, [ebx + edi + 6 + k]
                        mov dl,  [ebx + 2 * edi + 3 + k]
                        add eax, edx
                        lea eax, [eax + 2*eax]
                        mov dl,  [ebx + 2 * edi + 6 + k]
                        add eax, edx
                        add eax, ecx
                        shr eax, 4
                        mov [esi + edi + 3 + k], al ; output[WS+3] = (9 * A + 3 * (B+C) + D) / 16;
                    %assign k k+1 
                    %endrep
                ; FIN_LOOP_J
                add esi , 6
                add ebx, 3
                sub j, 1
                jnz .loopJ
            
        ; FIN_LOOP_I    
            add base, edi
            add Imagen, edi
            add Imagen, edi
            dec i
        jnz .loopI
        
        push auxBase
        call free
        add esp, 4
        
    popa
    leave
    ret



; extern "C" void asm_duplicarContraste_internal(unsigned char *Imagen, int h, int w, int ws);
asm_duplicarContraste_internal:
    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
        
    %define i      dword [ebp - 4*1]
    
    enter 4 * 1,0
    pusha

        ;int h = frame->height;
        ;int w = frame->width;
        ;const int WS = frame->widthStep;
        
        mov edi, Imagen ;uchar *base = (uchar*)frame->imageData;
        
        ;unsigned xm[3] = {0,0,0};
        xor eax, eax ;xm[0]
        xor ebx, ebx ;xm[1]
        xor ecx, ecx ;xm[2]
        
        xor edx, edx
        ; LOOP 1
        mov esi, h
        mov i, esi
        ; for(int i= 0 ; i< h ; i++)
.loop1_I:
            mov esi, w
            lea esi, [esi + 2*esi]
            add esi, edi ; const uchar *pos = base;
            
        .loop1_J:
                sub esi, 3
                ;for(int j = 0 ; j < w ; j ++)
                ;{
                    
                    ; forn(col,3)
                    ;    xm[col] += *pos++;
                    mov dl, [esi]
                    add eax, edx
                    mov dl, [esi+1]
                    add ebx, edx
                    mov dl, [esi+2]
                    add ecx, edx
                ;}
                cmp esi, edi
                jne .loop1_J
            add edi, ws ;  base += WS;
            dec i
            jnz .loop1_I
        ; FIN DE LOOP 1
        
        mov edi, h
        imul edi, w
        
        xor edx, edx
        div edi
        xchg eax, ebx
        xor edx, edx
        div edi
        xchg eax, ebx
        xchg eax, ecx
        xor edx, edx
        div edi
        xchg eax, ecx
        ;forn(col,3)
        ;    xm[col] /= h*w;
            
        mov edi, Imagen   
            
        xor edx, edx
        ; LOOP 2
        mov esi, h
        mov i, esi
        ; for(int i= 0 ; i< h ; i++)
.loop2_I:
            mov esi, w
            lea esi, [esi + 2*esi]
            add esi, edi ; const uchar *pos = base;
            
        .loop2_J:
                sub esi, 3
                ;for(int j = 0 ; j < w ; j ++)
                ;{
                    
                    ;forn(col,3)
                    ;{
                    ;    int newCol = 2 * *pos - xm[col];
                    ;    if (newCol < 0) newCol = 0;
                    ;    if (newCol > 255) newCol = 255;
                    ;    *pos++ = newCol;
                    ;}
                    %macro contrasteDoIt 2
                        mov dl, [esi + %2]
                        lea edx, [2 *edx]
                        sub edx, %1
                        jns %%sigue1
                            xor edx, edx
                            jmp %%sigue2
                    %%sigue1:
                        test edx, 0xFFFFFF00
                        jz %%sigue2
                            mov edx, 255
                    %%sigue2:
                        mov [esi + %2], dl
                    %endmacro
                    
                    contrasteDoIt eax,0
                    contrasteDoIt ebx,1
                    contrasteDoIt ecx,2
                ;}
                cmp esi, edi
                jne .loop2_J
            add edi, ws ;  base += WS;
            dec i
            jnz .loop2_I
        ; FIN DE LOOP 1
            
    popa
    leave
    ret


; extern "C" void asm_colorBalance_internal(unsigned char *Imagen, int h, int w, int ws, unsigned RED, unsigned GREEN, unsigned BLUE);
asm_colorBalance_internal:
    %define Imagen  dword [ebp + 8 + 4*0]
    %define h       dword [ebp + 8 + 4*1]
    %define w       dword [ebp + 8 + 4*2]
    %define ws      dword [ebp + 8 + 4*3]
    %define RED     dword [ebp + 8 + 4*4]
    %define GREEN   dword [ebp + 8 + 4*5]
    %define BLUE    dword [ebp + 8 + 4*6]
    
    %define i      dword [ebp - 4*1]
    
    enter 4 * 1,0
    pusha
        
        ; int h = frame->height;
        ; int w = frame->width;
        ; const int WS = frame->widthStep;
        
        mov esi, Imagen ;uchar *base = (uchar*)frame->imageData;
        
        ; unsigned colorCoef[3] = {c1,c2,c3};
        mov ebx, RED
        mov ecx, GREEN
        mov edx, BLUE
        
        xor eax, eax
        
        mov edi, h
        mov i, edi
        
        ;for(int i= 0 ; i< h ; i++)
        .loopI:
            mov edi, w
            lea edi, [edi + 2*edi]
            add edi, esi ;uchar *pos = base;
            
            ;for(int j = 0 ; j < w ; j ++)
            .loopJ:
                sub edi, 3
                    ;forn(col,3)
                    ;{
                        %macro balanceDoIt 2
                            ;int newCol = (colorCoef[col] * *pos ) / 128;
                            ;if (newCol > 255) newCol = 255;
                            ;*pos++ = newCol;
                            mov al, [edi + %2]
                            imul eax, %1
                            shr eax, 7
                            test eax, 0xFFFFFF00
                            jz %%ok
                                mov eax, 255
                            %%ok:
                            mov [edi + %2], al
                        %endmacro
                        
                        balanceDoIt ebx, 0
                        balanceDoIt ecx, 1
                        balanceDoIt edx, 2
                    ;}
                cmp edi, esi
                jne .loopJ
            
            add esi, ws
            dec i
            jnz .loopI
        
    popa
    leave
    ret

; extern "C" void asm_bokeh_internal(unsigned char *Imagen, int h, int w, int ws, unsigned kernelSize, unsigned AREA, unsigned *kernel, unsigned char *aux);
asm_bokeh_internal:

    %define Imagen     dword [ebp + 8 + 4*0]
    %define h          dword [ebp + 8 + 4*1]
    %define w          dword [ebp + 8 + 4*2]
    %define ws         dword [ebp + 8 + 4*3]
    %define kernelSize dword [ebp + 8 + 4*4]
    %define AREA       dword [ebp + 8 + 4*5]
    %define kernel     dword [ebp + 8 + 4*6]
    %define aux        dword [ebp + 8 + 4*7]
    
    %define i         dword [ebp - 4*1]
    %define output    dword [ebp - 4*2]
    %define input     dword [ebp - 4*3]
    %define total2    dword [ebp - 4*4]
    %define total1    dword [ebp - 4*5]
    %define total0    dword [ebp - 4*6]
    %define tope      dword [ebp - 4*7]
    %define inputPos  dword [ebp - 4*8]
    %define outputPos dword [ebp - 4*9]
    %define saveEcx   dword [ebp - 4*10]
    
    enter 4 * 10,0
    pusha

            mov eax, Imagen
            mov output, eax  ; uchar *output = (uchar*)frame->imageData;
            
            mov eax, aux
            mov input, eax  ; uchar *input = aux;
            
            mov i, 0
            
            ;for(int i= 0 ; i< h ; i++)
            ;{
.startMainLoop:

                ;unsigned total[3] = {0,0,0};
                mov total0, 0
                mov total1, 0
                mov total2, 0
                
                        ;forsn(ip, max(-int(kernelSize)+1, -i), min(h-i,int(kernelSize)))
                        ;{
                            mov ebx, h
                            sub ebx, i
                            mov edx, kernelSize
                            cmp ebx, edx
                            cmovl edx, ebx ; edx = min(h-i, kernelSize)
                            mov tope, edx
                        
                            mov ecx, kernelSize
                            dec ecx
                            mov eax, i
                            cmp eax, ecx
                            cmovl ecx, eax
                            neg ecx ; ecx = -min(kernelSize - 1, i) = max(-kernelSize+1, -i)
                        .totalCalculationLoop:
                            
                            ; ecx = ip
                            
                            mov eax, ecx
                            neg eax
                            cmovs eax, ecx ;eax = abs(ip)
                            
                            mov ebx, kernel
                            mov eax, [ebx + 4*eax] ; eax = kernel[abs(ip)]
                            
                            mov esi, w
                            cmp esi, eax
                            cmovl eax, esi ; eax = min(w,kernel[abs(ip)])
                        
                            mov esi, input
                            mov edi, ws
                            imul edi, ecx
                            add esi, edi ; esi = input + WS * ip
                            
                            mov edx , total0
                            mov edi , total1
                            mov ebx , total2
                            
                            mov saveEcx, ecx
                            xor ecx, ecx
                            .miniColorLoop:
                                    
                                    ; eax = j+1
                                    
                                    ;    forn(j,k[abs(ip)])
                                    ;    if (j < w)
                                    ;    forn(col,3)
                                    ;        total[col] += input[WS*ip + 3 * j + col];
                                    
                                    mov cl, [esi]
                                    add edx, ecx
                                    mov cl, [esi+1]
                                    add edi, ecx
                                    mov cl, [esi+2]
                                    add ebx, ecx
                                    
                                    add esi, 3
                                    
                                    dec eax
                                    jnz .miniColorLoop
                            
                            mov ecx, saveEcx
                            
                            mov total0 , edx
                            mov total1 , edi
                            mov total2 , ebx
                            
                            inc ecx
                            cmp ecx, tope
                            jne .totalCalculationLoop
                        
                        ;}
                
                
                ; En este punto ya estan computados los totales iniciales.
                
                            
                            ;uchar *inputPos = input; 
                            ;uchar *outputPos = output;
                            
                            mov eax, output
                            mov outputPos, eax

                            mov ebx, input
                            
                            xor edi, edi ; edi = j = 0
                            .primerParteFor:
                                mov esi, outputPos
                                
                                    xor edx, edx
                                    mov eax, total0
                                    div AREA
                                    mov [esi], al
                                    
                                    xor edx, edx
                                    mov eax, total1
                                    div AREA
                                    mov [esi+1], al
                                    
                                    xor edx, edx
                                    mov eax, total2
                                    div AREA
                                    mov [esi+2], al
                                    
                                    add outputPos, 3
                                    
                                    ; *outputPos++ = total[col] / AREA;
                                    
                                    ;// Quitar uno a izquierda, meter uno a derecha
                                    
                                    
                                    
                                    mov eax, kernelSize
                                    dec eax
                                    mov ecx, i
                                    cmp eax, ecx
                                    cmovl ecx, eax 
                                    test ecx, ecx ; ecx = min(kernelSize-1,i)
                                    jz .fueraPrimerForsn
                                    
                                        mov edx, kernel
                                        
                                        mov inputPos, ebx
                                        .primerForsn:
                                            
                                            ;forsn(ip, 1, min(kernelSize-1, i))
                                            ;{
                                                sub ebx, ws
                                                ;const int D = k[ip];
                                                mov eax, [edx + 4]
                                                add edx, 4 ; eax = D
                                                lea esi, [edi + eax]
                                                cmp esi, w
                                                jge .noSumar1
                                                    ;if (j+D < w)
                                                    ;    total[col] += inputPos[-WS*ip + 3*D];
                                                    lea esi, [eax + 2*eax]
                                                    xor eax, eax
                                                    mov al, [ebx + esi]
                                                    add total0, eax
                                                    mov al, [ebx + esi + 1]
                                                    add total1, eax
                                                    mov al, [ebx + esi + 2]
                                                    add total2, eax
                                                    mov eax, [edx]
                                                .noSumar1:
                                                neg eax ; eax = -D
                                                lea esi, [edi + eax + 1]
                                                test esi, esi
                                                js .noRestar1
                                                    ;if (j-D+1 >= 0)
                                                    ;    total[col] -=  inputPos[-WS*ip - 3*(D-1)];
                                                    lea esi, [eax + 2*eax]
                                                    xor eax, eax
                                                    mov al, [ebx + esi + 3]
                                                    sub total0, eax
                                                    mov al, [ebx + esi + 4]
                                                    sub total1, eax
                                                    mov al, [ebx + esi + 5]
                                                    sub total2, eax
                                                .noRestar1:
                                            ;}
                                            dec ecx
                                            jnz .primerForsn
                                        mov ebx, inputPos
                                    .fueraPrimerForsn:
                                    
                                    
                                    
                                    
                                    
                                    mov eax, kernelSize
                                    mov ecx, h
                                    sub ecx, i
                                    cmp eax, ecx
                                    cmovl ecx, eax ; ecx = min(h-i, kernelSize)
                                     
                                        mov edx, kernel
                                        
                                        mov inputPos, ebx
                                        .segundoForsn:
                                            
                                            ; forsn(ip, 0, min(h-i,kernelSize))
                                            ;{
                                                ;const int D = k[ip];
                                                mov eax, [edx]
                                                add edx, 4 ; eax = D
                                                lea esi, [edi + eax]
                                                cmp esi, w
                                                jge .noSumar2
                                                    ;if (j+D < w)
                                                    ;    total[col] += inputPos[WS*ip + 3*D];
                                                    lea esi, [eax + 2*eax]
                                                    xor eax, eax
                                                    mov al, [ebx + esi]
                                                    add total0, eax
                                                    mov al, [ebx + esi + 1]
                                                    add total1, eax
                                                    mov al, [ebx + esi + 2]
                                                    add total2, eax
                                                    mov eax, [edx - 4]
                                                .noSumar2:
                                                neg eax ; eax = -D
                                                lea esi, [edi + eax + 1]
                                                test esi, esi
                                                js .noRestar2
                                                    ;if (j-D+1 >= 0)
                                                    ;    total[col] -=  inputPos[WS*ip - 3*(D-1)];
                                                    lea esi, [eax + 2*eax]
                                                    xor eax, eax
                                                    mov al, [ebx + esi + 3]
                                                    sub total0, eax
                                                    mov al, [ebx + esi + 4]
                                                    sub total1, eax
                                                    mov al, [ebx + esi + 5]
                                                    sub total2, eax
                                                .noRestar2:
                                                add ebx, ws
                                            ;}
                                            dec ecx
                                            jnz .segundoForsn
                                        mov ebx, inputPos
                                    

                                ;    inputPos++;
                                ;}
                                add ebx, 3
                            inc edi
                            cmp edi, w; kernelSize
                            jne .primerParteFor
                            
                            mov eax, ws
                            add output, eax
                            add input , eax
                            ;output += WS;
                            ;input  += WS;

            
            mov eax, i
            inc eax
            mov i, eax
            cmp eax, h
            jne .startMainLoop
            ;}

    popa
    leave
    ret


; extern "C" void asm_nearestRot_internal(unsigned char *Imagen, int h, int w, int ws, unsigned char * aux, float sinAlpha, float cosAlpha);
asm_nearestRot_internal:

    %define Imagen   dword [ebp + 8 + 4*0]
    %define h        dword [ebp + 8 + 4*1]
    %define w        dword [ebp + 8 + 4*2]
    %define ws       dword [ebp + 8 + 4*3]
    %define aux      dword [ebp + 8 + 4*4]
    %define sinAlpha  [ebp + 8 + 4*5]
    %define cosAlpha  [ebp + 8 + 4*6]
    
    %define output   dword [ebp - 4*1]
    %define i        dword [ebp - 4*2]
    enter 4 * 2,0
    pusha

                    movss xmm0, sinAlpha
                    movss xmm1, cosAlpha
                    
                    ;uchar *output = Imagen;
                    mov eax, Imagen
                    mov output, eax
                    
                    
                    
                    
                    ;const int cx = h/2, cy = w/2;
                    
                    mov ecx, h
                    shr ecx, 1 ; ecx = cx
                    
                    mov ebx, w
                    shr ebx, 1 ; ebx = cy
                    
                    mov eax, ecx
                    neg eax
                    cvtsi2ss xmm2, eax ; xmm2 = -cx     (i - cx)
                    
                    mov eax, 1
                    cvtsi2ss xmm3, eax ; xmm3 = 1 
                    
                    mov esi, h
                    mov i, esi
                    .iLoop:
                    ;for(int i= 0 ; i< h ; i++)
                    ;{
                        
                        mov eax, ebx
                        neg eax
                        cvtsi2ss xmm4, eax ; xmm2 = -cy     (j - cy)
                        
                        ;uchar *outputPos = output;
                        mov edx, output ; edx = outputPos
                        
                        mov edi, w
                        .jLoop:
                        ;for(int j = 0 ; j < w ; j ++)
                        ;{
                            
                            ;const int ri = round(cx + cosAlpha * (i - cx) - sinAlpha * (j - cy) );
                            movss xmm5, xmm2
                            mulss xmm5, xmm1
                            movss xmm6, xmm4
                            mulss xmm6, xmm0
                            subss xmm5, xmm6
                            
                            cvtss2si eax, xmm5 ; eax = ri
                            add eax, ecx
                            
                            js .finLoop
                            cmp eax, h
                            jge .finLoop
                            
                            ;const int rj = round(cy + sinAlpha * (i - cx) + cosAlpha * (j - cy) );
                            movss xmm5, xmm2
                            mulss xmm5, xmm0
                            movss xmm6, xmm4
                            mulss xmm6, xmm1
                            addss xmm5, xmm6
                            
                            cvtss2si esi, xmm5 ; esi = rj
                            add esi, ebx
                            
                            js .finLoop
                            cmp esi, w
                            jge .finLoop
                            
                                ; Copiamos el nearest neighbor
                                lea esi, [2*esi + esi]
                                imul eax, ws
                                add eax, aux
                                mov esi, [eax + esi]
                                mov dword [edx], esi
                                lea edx, [edx + 3]
                            addss xmm4, xmm3
                                
                            dec edi
                            jnz .jLoop
                            jmp .afuera
                            ;if (0 <= ri && ri < h && 0 <= rj && rj < w)
                            ;    forn(col,3) *outputPos++ = aux[ws*ri+3*rj+col];
                            ;else
                            ;    forn(col,3) *outputPos++ = 0;
                            
                            .finLoop:
                            
                                ; Mechamos un pixel negro
                                mov dword [edx], 0
                                lea edx, [edx + 3]
                                
                            addss xmm4, xmm3
                                
                            dec edi
                            jnz .jLoop
                        ;}
                        .afuera:
                        
                        mov eax, ws
                        add output, eax
                        ;output += ws;
                        
                        addss xmm2, xmm3
                        
                        dec i
                        jnz .iLoop
                    ;}


    popa
    leave
    ret
