#include "filtroAsm.h"
#include "FuncionesAsm.h"
#include "filtro.h"

void asm_invertir(IplImage * frame)
{
	asm_invertir((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);

}
void asm_bordesSimples(IplImage * frame)
{
	asm_bordesSimples((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void asm_bordesSobel(IplImage * frame)
{
	asm_bordesSobel((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void asm_BlackAndWhite(IplImage * frame)
{
	asm_BlackAndWhite((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void asm_zoom(IplImage * frame)
{
	asm_zoom((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void asm_fotoBinaria(IplImage * frame)
{
	asm_fotoBinaria((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void asm_filtroGauseano(IplImage * frame, bool ByN)
{
	asm_filtroGauseano((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, ByN);
}

void asm_bordesCanny(IplImage * frame, bool ByN, bool binario)
{
	asm_bordesCanny((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep,ByN,binario);
}


void asm_zoomBillinear(IplImage *frame)
{
	asm_zoomBillinear((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}

void asm_duplicarContraste(IplImage *frame)
{
	asm_duplicarContraste((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}

void asm_colorBalance(IplImage *frame, unsigned c1, unsigned c2, unsigned c3)
{
    asm_colorBalance((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, c1,c2,c3);
}

void asm_bokeh(IplImage *frame,unsigned kernelSize)
{
    asm_bokeh((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, kernelSize);
}

void asm_nearestRot(IplImage *frame,float alpha)
{
    asm_nearestRot((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, alpha);
}

void asm_CambiarFrameAUnaSeccion(IplImage * frame, int h,int w,char* comienzo,int seccion)
{	
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,seccion);
}
void asm_todasJuntas(IplImage * frame)
{
	int h = (*frame).height;
	int w = (*frame).width;	
	char*comienzo = (*frame).imageData;
	asm_CambiarFrameAUnaSeccion(frame,h,w,comienzo,0);
	asm_BlackAndWhite(frame);
	asm_CambiarFrameAUnaSeccion(frame,h,w,comienzo,1);
	asm_invertir(frame);		
	asm_CambiarFrameAUnaSeccion(frame,h,w,comienzo,6);
	asm_bordesSimples(frame);
	asm_CambiarFrameAUnaSeccion(frame,h,w,comienzo,7);
	asm_bordesSobel(frame);
	asm_CambiarFrameAUnaSeccion(frame,h,w,comienzo,2);
	asm_fotoBinaria(frame);
	asm_CambiarFrameAUnaSeccion(frame,h,w,comienzo,3);
	asm_zoom(frame);
	asm_CambiarFrameAUnaSeccion(frame,h,w,comienzo,5);
	asm_filtroGauseano(frame, false);
	asm_CambiarFrameAUnaSeccion(frame,h,w,comienzo,8);
	asm_bordesCanny(frame, false,false);

	(*frame).height = h;
	(*frame).width = w;
	(*frame).imageData = comienzo;

	return;
}/**/


