#include "filtroSSE.h"
#include "FuncionesSSE.h"
#include "filtro.h"

void sse_invertir(IplImage * frame)
{
	sse_invertir((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);

}
void sse_bordesSimples(IplImage * frame)
{
	sse_bordesSimples((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void sse_bordesSobel(IplImage * frame)
{
	sse_bordesSobel((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void sse_BlackAndWhite(IplImage * frame)
{
	sse_BlackAndWhite((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void sse_zoom(IplImage * frame)
{
	sse_zoom((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void sse_fotoBinaria(IplImage * frame)
{
	sse_fotoBinaria((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}
void sse_filtroGauseano(IplImage * frame, bool ByN)
{
	sse_filtroGauseano((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, ByN);
}

void sse_bordesCanny(IplImage * frame, bool ByN, bool binario)
{
	sse_bordesCanny((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep,ByN,binario);
}


void sse_CambiarFrameAUnaSeccion(IplImage * frame, int h,int w,char* comienzo,int seccion)
{	
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,seccion);

}
void sse_todasJuntas(IplImage * frame)
{
	int h = (*frame).height;
	int w = (*frame).width;	
	char*comienzo = (*frame).imageData;
	sse_CambiarFrameAUnaSeccion(frame,h,w,comienzo,0);
	sse_BlackAndWhite(frame);
	sse_CambiarFrameAUnaSeccion(frame,h,w,comienzo,1);
	sse_invertir(frame);		
	sse_CambiarFrameAUnaSeccion(frame,h,w,comienzo,6);
	sse_bordesSimples(frame);
	sse_CambiarFrameAUnaSeccion(frame,h,w,comienzo,7);
	sse_bordesSobel(frame);
	sse_CambiarFrameAUnaSeccion(frame,h,w,comienzo,2);
	sse_fotoBinaria(frame);
	sse_CambiarFrameAUnaSeccion(frame,h,w,comienzo,3);
	sse_zoom(frame);
	sse_CambiarFrameAUnaSeccion(frame,h,w,comienzo,5);
	sse_filtroGauseano(frame, false);
	sse_CambiarFrameAUnaSeccion(frame,h,w,comienzo,8);
	sse_bordesCanny(frame, false,false);

	(*frame).height = h;
	(*frame).width = w;
	(*frame).imageData = comienzo;

	return;
}/**/


void sse_zoomBillinear(IplImage *frame)
{
	sse_zoomBillinear((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}

void sse_duplicarContraste(IplImage *frame)
{
	sse_duplicarContraste((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep);
}

void sse_colorBalance(IplImage *frame, unsigned c1, unsigned c2, unsigned c3)
{
    sse_colorBalance((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, c1,c2,c3);
}

void sse_bokeh(IplImage *frame,unsigned kernelSize)
{
    sse_bokeh((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, kernelSize);
}

void sse_nearestRot(IplImage *frame,float alpha)
{
    sse_nearestRot((unsigned char*)(*frame).imageData,(*frame).height, (*frame).width,(*frame).widthStep, alpha);
}
